WITH Taxonomy (user_var, name_var, key1, key2, key3, level_var, sort_var)
AS
(
-- Anchor member definition
    SELECT DISTINCT mtable1.user_tag_ident, mtable1.name, ctable1.ev_db_site, ctable1.ev_db_id, ctable1.event_type_code, 0, cast(mtable1.user_tag_ident as varchar(1000)) 
    FROM event_type_child AS ctable1
    INNER JOIN sg_as_event_type as mtable1
        ON mtable1.ev_db_site = ctable1.ev_db_site AND
           mtable1.ev_db_id = ctable1.ev_db_id AND
		   mtable1.event_type_code = ctable1.event_type_code
    LEFT OUTER JOIN event_type_child AS ctable2
        ON ctable2.child_ev_db_site = ctable1.ev_db_site AND
           ctable2.child_ev_db_id = ctable1.ev_db_id AND
		   ctable2.child_ev_type_code = ctable1.event_type_code
    WHERE  ctable2.child_ev_db_site IS NULL AND
           ctable1.rstat_type_code = 1 
UNION ALL
-- Recursive member definition
   SELECT mtable2.user_tag_ident, mtable2.name, ctable3.child_ev_db_site, ctable3.child_ev_db_id, ctable3.child_ev_type_code,
		ctable4.level_var + 1, cast((ctable4.sort_var+'\'+mtable2.user_tag_ident+'\'+ctable3.child_ev_db_site+'.'+LTRIM(STR(ctable3.child_ev_db_id))+'.'+LTRIM(STR(ctable3.child_ev_type_code))) as varchar(1000))
    FROM event_type_child AS ctable3
    INNER JOIN sg_as_event_type as mtable2
        ON mtable2.ev_db_site = ctable3.ev_db_site AND
           mtable2.ev_db_id = ctable3.ev_db_id AND
	       mtable2.event_type_code = ctable3.event_type_code
    INNER JOIN Taxonomy AS ctable4
        ON ctable3.ev_db_site = ctable4.key1 AND
		   ctable3.ev_db_id = ctable4.key2 AND
		   ctable3.event_type_code = ctable4.key3
     WHERE ctable3.rstat_type_code = 1 and ctable4.level_var < 100
)
-- Statement that executes the CTE
SELECT substring('                                    ',1,ctable4.level_var*4)+mtable3.user_tag_ident, mtable3.name,
		ctable4.key1+'.'+LTRIM(STR(ctable4.key2))+'.'+LTRIM(STR(ctable4.key3)), ctable4.key3, ctable4.level_var, LTRIM(ctable4.sort_var)
FROM Taxonomy AS ctable4
INNER JOIN sg_as_event_type as mtable3
        ON mtable3.ev_db_site = ctable4.key1 AND
	       mtable3.ev_db_id = ctable4.key2 AND
		   mtable3.event_type_code = ctable4.key3
ORDER BY ctable4.sort_var
GO
