WITH Taxonomy (user_var, name_var, key1, key2, key3, level_var, sort_var)
AS
(
-- Anchor member definition
    SELECT DISTINCT mtable1.user_tag_ident, mtable1.name, ctable1.task_db_site, ctable1.task_db_id, ctable1.task_type_code, 0, cast(mtable1.user_tag_ident as varchar(1000)) 
    FROM wtask_type_child AS ctable1
    INNER JOIN work_task_type as mtable1
        ON mtable1.task_db_site = ctable1.task_db_site AND
           mtable1.task_db_id = ctable1.task_db_id AND
		   mtable1.task_type_code = ctable1.task_type_code
    LEFT OUTER JOIN wtask_type_child AS ctable2
        ON ctable2.child_tk_db_site = ctable1.task_db_site AND
           ctable2.child_tk_db_id = ctable1.task_db_id AND
		   ctable2.child_tk_type_code = ctable1.task_type_code
    WHERE  ctable2.child_tk_db_site IS NULL AND
           ctable1.rstat_type_code = 1 
UNION ALL
-- Recursive member definition
   SELECT mtable2.user_tag_ident, mtable2.name, ctable3.child_tk_db_site, ctable3.child_tk_db_id, ctable3.child_tk_type_code,
		ctable4.level_var + 1, cast(ctable4.sort_var+'\'+mtable.user_tag_ident as varchar(1000))
    FROM wtask_type_child AS ctable3
    INNER JOIN work_task_type as mtable2
        ON mtable2.task_db_site = ctable3.task_db_site AND
           mtable2.task_db_id = ctable3.task_db_id AND
	       mtable2.task_type_code = ctable3.task_type_code
    INNER JOIN work_task_type as mtable
        ON mtable.task_db_site = ctable3.child_tk_db_site AND
           mtable.task_db_id = ctable3.child_tk_db_id AND
	       mtable.task_type_code = ctable3.child_tk_type_code
    INNER JOIN Taxonomy AS ctable4
        ON ctable3.task_db_site = ctable4.key1 AND
		   ctable3.task_db_id = ctable4.key2 AND
		   ctable3.task_type_code = ctable4.key3
     WHERE ctable3.rstat_type_code = 1 and ctable4.level_var < 100
)
-- Statement that executes the CTE
SELECT substring('                              ',1,ctable4.level_var*4)+mtable3.user_tag_ident, mtable3.name,
		ctable4.key1+'.'+LTRIM(STR(ctable4.key2))+'.'+LTRIM(STR(ctable4.key3)), ctable4.key3, ctable4.level_var, LTRIM(ctable4.sort_var)
FROM Taxonomy AS ctable4
INNER JOIN work_task_type as mtable3
        ON mtable3.task_db_site = ctable4.key1 AND
	       mtable3.task_db_id = ctable4.key2 AND
		   mtable3.task_type_code = ctable4.key3
ORDER BY ctable4.sort_var
GO
