<?xml version="1.0"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xpath-default-namespace="http://www.mimosa.org/TechXMLV3-2">
<!-- replace all occurrences in a string -->
<xsl:template name="string-replace-all">
  <xsl:param name="text"/>
  <xsl:param name="replace"/>
  <xsl:param name="with"/>
  <xsl:choose>
     <xsl:when test="contains($text, $replace)">
       <xsl:value-of select="substring-before($text,$replace)"/>
	   <xsl:value-of select="$with"/>
	   <xsl:call-template name="string-replace-all">
	     <xsl:with-param name="text" select="substring-after($text,$replace)"/>
		 <xsl:with-param name="replace" select="$replace"/>
		 <xsl:with-param name="with" select="$with"/>
	   </xsl:call-template>
	 </xsl:when>
	 <xsl:otherwise>
	   <xsl:value-of select="$text"/>
	 </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template match="mim_cris_v32">
  <xsl:for-each select="*">
	<xsl:text>INSERT INTO </xsl:text>
	<xsl:value-of select="name()"/>
	<xsl:text>(</xsl:text>
	<xsl:for-each select="@*">
		<xsl:if test="position()>1"><xsl:text>,</xsl:text></xsl:if>
		<xsl:value-of select="name()"/>
	</xsl:for-each>
	<xsl:text>) VALUES(</xsl:text>
	<xsl:for-each select="@*">
		<xsl:if test="position()>1"><xsl:text>,</xsl:text></xsl:if>
		<xsl:choose>
 		 <xsl:when test="starts-with(name(), 'gmt_')"> 
			<xsl:text>CONVERT(DATETIME, '</xsl:text>
  		    <xsl:value-of select="."/>
			<xsl:text>', 126)</xsl:text>
 		 </xsl:when>
    	         <xsl:otherwise>
		    <xsl:text>'</xsl:text>
			<xsl:variable name="result">
			  <xsl:call-template name="string-replace-all">
			    <xsl:with-param name="text" select="."/>
				<xsl:with-param name="replace" select='"&apos;"'/>
				<xsl:with-param name="with" select='"&apos;&apos;"'/>
			  </xsl:call-template>
			</xsl:variable>
			<xsl:value-of select="$result"/>
		    <xsl:text>'</xsl:text>
	         </xsl:otherwise>
                </xsl:choose>
	</xsl:for-each>
	<xsl:text>);
</xsl:text>
  </xsl:for-each>
	
</xsl:template>

</xsl:stylesheet><!-- Stylus Studio meta-information - (c) 2004-2008. Progress Software Corporation. All rights reserved.

<metaInformation>
	<scenarios>
		<scenario default="yes" name="test3" userelativepaths="yes" externalpreview="yes" url="..\..\1 - Data Dictionaries\CRIS V3.2.1\01-MIMOSA CRIS Reference\[OSA-EAI-CRIS-REF-XML-V03-2]CRIS_Reference_Library_V3-2-1[12-Nov-2009].xml" htmlbaseurl=""
		          outputurl="..\..\1 - Data Dictionaries\CRIS V3.2.1\01-MIMOSA CRIS Reference\[OSA-EAI-CRIS-REF-XML-V03-2]V3.2.1-2009-11-12.sqlserver" processortype="saxon8" useresolver="yes" profilemode="0" profiledepth="" profilelength=""
		          urlprofilexml="" commandline="" additionalpath="" additionalclasspath="" postprocessortype="none" postprocesscommandline="" postprocessadditionalpath="" postprocessgeneratedext="" validateoutput="no" validator="internal"
		          customvalidator="">
			<advancedProp name="sInitialMode" value=""/>
			<advancedProp name="bXsltOneIsOkay" value="true"/>
			<advancedProp name="bSchemaAware" value="true"/>
			<advancedProp name="bXml11" value="false"/>
			<advancedProp name="iValidation" value="0"/>
			<advancedProp name="bExtensions" value="true"/>
			<advancedProp name="iWhitespace" value="0"/>
			<advancedProp name="sInitialTemplate" value=""/>
			<advancedProp name="bTinyTree" value="true"/>
			<advancedProp name="bWarnings" value="true"/>
			<advancedProp name="bUseDTD" value="false"/>
			<advancedProp name="iErrorHandling" value="fatal"/>
		</scenario>
	</scenarios>
	<MapperMetaTag>
		<MapperInfo srcSchemaPathIsRelative="yes" srcSchemaInterpretAsXML="no" destSchemaPath="" destSchemaRoot="" destSchemaPathIsRelative="yes" destSchemaInterpretAsXML="no"/>
		<MapperBlockPosition></MapperBlockPosition>
		<TemplateContext></TemplateContext>
		<MapperFilter side="source"></MapperFilter>
	</MapperMetaTag>
</metaInformation>
-->